/*
 * generated by Fujaba - CodeGen2
 */
package de.uks.pmss11.wizard;
import de.uni_kassel.features.annotation.util.Property; // requires Fujaba5/libs/features.jar in classpath
import de.uni_kassel.features.ReferenceHandler; // requires Fujaba5/libs/features.jar in classpath
import java.util.*;
import de.upb.tools.fca.*; // requires Fujaba5/libs/RuntimeTools.jar in classpath


public class Card
{



   public static final String PROPERTY_COLOR = "color";

   @Property( name = PROPERTY_COLOR, kind = ReferenceHandler.ReferenceKind.ATTRIBUTE )
   private String color;

   @Property( name = PROPERTY_COLOR )
   public void setColor (String value)
   {
      this.color = value;
   }

   public Card withColor (String value)
   {
      setColor (value);
      return this;
   }

   @Property( name = PROPERTY_COLOR )
   public String getColor ()
   {
      return this.color;
   }

   /**
    * <pre>
    *           0..n     cards     0..1
    * Card ------------------------- Player
    *           cards               player
    * </pre>
    */
   public static final String PROPERTY_PLAYER = "player";

   @Property( name = PROPERTY_PLAYER, partner = Player.PROPERTY_CARDS, kind = ReferenceHandler.ReferenceKind.TO_ONE,
         adornment = ReferenceHandler.Adornment.NONE)
   private Player player;

   @Property( name = PROPERTY_PLAYER )
   public boolean setPlayer (Player value)
   {
      boolean changed = false;

      if (this.player != value)
      {
      
         Player oldValue = this.player;
         Card source = this;
         if (this.player != null)
         {
            this.player = null;
            oldValue.removeFromCards (this);
         }
         this.player = value;

         if (value != null)
         {
            value.addToCards (this);
         }
         changed = true;
      
      }
      return changed;
   }

   @Property( name = PROPERTY_PLAYER )
   public Card withPlayer (Player value)
   {
      setPlayer (value);
      return this;
   }

   public Player getPlayer ()
   {
      return this.player;
   }

   /**
    * <pre>
    *           0..n     cards     0..1
    * Card ------------------------- Stack
    *           cards               stack
    * </pre>
    */
   public static final String PROPERTY_STACK = "stack";

   @Property( name = PROPERTY_STACK, partner = Stack.PROPERTY_CARDS, kind = ReferenceHandler.ReferenceKind.TO_ONE,
         adornment = ReferenceHandler.Adornment.NONE)
   private Stack stack;

   @Property( name = PROPERTY_STACK )
   public boolean setStack (Stack value)
   {
      boolean changed = false;

      if (this.stack != value)
      {
      
         Stack oldValue = this.stack;
         Card source = this;
         if (this.stack != null)
         {
            this.stack = null;
            oldValue.removeFromCards (this);
         }
         this.stack = value;

         if (value != null)
         {
            value.addToCards (this);
         }
         changed = true;
      
      }
      return changed;
   }

   @Property( name = PROPERTY_STACK )
   public Card withStack (Stack value)
   {
      setStack (value);
      return this;
   }

   public Stack getStack ()
   {
      return this.stack;
   }

   /**
    * <pre>
    *           0..n     cards     0..n
    * Card ------------------------- Trick
    *           cards               tricks
    * </pre>
    */
   public static final String PROPERTY_TRICKS = "tricks";

   @Property( name = PROPERTY_TRICKS, partner = Trick.PROPERTY_CARDS, kind = ReferenceHandler.ReferenceKind.TO_MANY,
         adornment = ReferenceHandler.Adornment.NONE)
   private FHashSet<Trick> tricks;

   @Property( name = PROPERTY_TRICKS )
   public Set<? extends Trick> getTricks()
   {
      return ((this.tricks == null)
              ? Collections.EMPTY_SET
              : Collections.unmodifiableSet(this.tricks));
   }

   @Property( name = PROPERTY_TRICKS )
   public boolean addToTricks (Trick value)
   {
      boolean changed = false;

      if (value != null)
      {
         if (this.tricks == null)
         {
            this.tricks = new FHashSet<Trick> ();

         }
      
         changed = this.tricks.add (value);
         if (changed)
         {
            value.addToCards (this);
         }
      
      }
      return changed;
   }

   @Property( name = PROPERTY_TRICKS )
   public Card withTricks (Trick value)
   {
      addToTricks (value);
      return this;
   }

   public Card withoutTricks (Trick value)
   {
      removeFromTricks (value);
      return this;
   }


   public boolean removeFromTricks (Trick value)
   {
      boolean changed = false;

      if ((this.tricks != null) && (value != null))
      {
      
         changed = this.tricks.remove (value);
         if (changed)
         {
            value.removeFromCards (this);
         }
      
      }
      return changed;
   }

   @Property( name = PROPERTY_TRICKS )
   public void removeAllFromTricks (){
   
      Trick tmpValue;
      Iterator<? extends Trick> iter = this.iteratorOfTricks ();
      while (iter.hasNext ())
      {
         tmpValue = (Trick) iter.next ();
         this.removeFromTricks (tmpValue);
      }
   
   }

   @Property( name = PROPERTY_TRICKS )
   public boolean hasInTricks (Trick value)
   {
      return ((this.tricks != null) &&
              (value != null) &&
              this.tricks.contains (value));
   }

   @Property( name = PROPERTY_TRICKS )
   public Iterator<? extends Trick> iteratorOfTricks ()
   {
      return ((this.tricks == null)
              ? FEmptyIterator.<Trick>get ()
              : this.tricks.iterator ());
   }

   @Property( name = PROPERTY_TRICKS )
   public int sizeOfTricks ()
   {
      return ((this.tricks == null)
              ? 0
              : this.tricks.size ());
   }

   /**
    * <pre>
    *           0..1     trump     0..1
    * Card ------------------------- Turn
    *           trump               turn
    * </pre>
    */
   public static final String PROPERTY_TURN = "turn";

   @Property( name = PROPERTY_TURN, partner = Turn.PROPERTY_TRUMP, kind = ReferenceHandler.ReferenceKind.TO_ONE,
         adornment = ReferenceHandler.Adornment.NONE)
   private Turn turn;

   @Property( name = PROPERTY_TURN )
   public boolean setTurn (Turn value)
   {
      boolean changed = false;

      if (this.turn != value)
      {
      
         Turn oldValue = this.turn;
         Card source = this;
         if (this.turn != null)
         {
            this.turn = null;
            oldValue.setTrump (null);
         }
         this.turn = value;

         if (value != null)
         {
            value.setTrump (this);
         }
         changed = true;
      
      }
      return changed;
   }

   @Property( name = PROPERTY_TURN )
   public Card withTurn (Turn value)
   {
      setTurn (value);
      return this;
   }

   public Turn getTurn ()
   {
      return this.turn;
   }

   public static final String PROPERTY_VALUE = "value";

   @Property( name = PROPERTY_VALUE, kind = ReferenceHandler.ReferenceKind.ATTRIBUTE )
   private int value;

   @Property( name = PROPERTY_VALUE )
   public void setValue (int value)
   {
      this.value = value;
   }

   public Card withValue (int value)
   {
      setValue (value);
      return this;
   }

   @Property( name = PROPERTY_VALUE )
   public int getValue ()
   {
      return this.value;
   }

   public void removeYou()
   {
      this.setPlayer (null);
      this.setStack (null);
      this.removeAllFromTricks ();
      this.setTurn (null);
   }
}


