/*
 * generated by Fujaba - CodeGen2
 */
package de.uks.pmss11.wizard;
import de.uni_kassel.features.annotation.util.Property; // requires Fujaba5/libs/features.jar in classpath
import de.uni_kassel.features.ReferenceHandler; // requires Fujaba5/libs/features.jar in classpath
import java.util.*;
import de.upb.tools.fca.*; // requires Fujaba5/libs/RuntimeTools.jar in classpath


public class Player
{



   /**
    * <pre>
    *           0..1     cards     0..n
    * Player ------------------------- Card
    *           player               cards
    * </pre>
    */
   public static final String PROPERTY_CARDS = "cards";

   @Property( name = PROPERTY_CARDS, partner = Card.PROPERTY_PLAYER, kind = ReferenceHandler.ReferenceKind.TO_MANY,
         adornment = ReferenceHandler.Adornment.NONE)
   private FHashSet<Card> cards;

   @Property( name = PROPERTY_CARDS )
   public Set<? extends Card> getCards()
   {
      return ((this.cards == null)
              ? Collections.EMPTY_SET
              : Collections.unmodifiableSet(this.cards));
   }

   @Property( name = PROPERTY_CARDS )
   public boolean addToCards (Card value)
   {
      boolean changed = false;

      if (value != null)
      {
         if (this.cards == null)
         {
            this.cards = new FHashSet<Card> ();

         }
      
         changed = this.cards.add (value);
         if (changed)
         {
            value.setPlayer (this);
         }
      
      }
      return changed;
   }

   @Property( name = PROPERTY_CARDS )
   public Player withCards (Card value)
   {
      addToCards (value);
      return this;
   }

   public Player withoutCards (Card value)
   {
      removeFromCards (value);
      return this;
   }


   public boolean removeFromCards (Card value)
   {
      boolean changed = false;

      if ((this.cards != null) && (value != null))
      {
      
         changed = this.cards.remove (value);
         if (changed)
         {
            value.setPlayer (null);
         }
      
      }
      return changed;
   }

   @Property( name = PROPERTY_CARDS )
   public void removeAllFromCards (){
   
      Card tmpValue;
      Iterator<? extends Card> iter = this.iteratorOfCards ();
      while (iter.hasNext ())
      {
         tmpValue = (Card) iter.next ();
         this.removeFromCards (tmpValue);
      }
   
   }

   @Property( name = PROPERTY_CARDS )
   public boolean hasInCards (Card value)
   {
      return ((this.cards != null) &&
              (value != null) &&
              this.cards.contains (value));
   }

   @Property( name = PROPERTY_CARDS )
   public Iterator<? extends Card> iteratorOfCards ()
   {
      return ((this.cards == null)
              ? FEmptyIterator.<Card>get ()
              : this.cards.iterator ());
   }

   @Property( name = PROPERTY_CARDS )
   public int sizeOfCards ()
   {
      return ((this.cards == null)
              ? 0
              : this.cards.size ());
   }

   /**
    * <pre>
    *           0..1     currentPlayer     0..1
    * Player ------------------------- WizardGame
    *           currentPlayer               currentPlayerRev
    * </pre>
    */
   public static final String PROPERTY_CURRENT_PLAYER_REV = "currentPlayerRev";

   @Property( name = PROPERTY_CURRENT_PLAYER_REV, partner = WizardGame.PROPERTY_CURRENT_PLAYER, kind = ReferenceHandler.ReferenceKind.TO_ONE,
         adornment = ReferenceHandler.Adornment.NONE)
   private WizardGame currentPlayerRev;

   @Property( name = PROPERTY_CURRENT_PLAYER_REV )
   public boolean setCurrentPlayerRev (WizardGame value)
   {
      boolean changed = false;

      if (this.currentPlayerRev != value)
      {
      
         WizardGame oldValue = this.currentPlayerRev;
         Player source = this;
         if (this.currentPlayerRev != null)
         {
            this.currentPlayerRev = null;
            oldValue.setCurrentPlayer (null);
         }
         this.currentPlayerRev = value;

         if (value != null)
         {
            value.setCurrentPlayer (this);
         }
         changed = true;
      
      }
      return changed;
   }

   @Property( name = PROPERTY_CURRENT_PLAYER_REV )
   public Player withCurrentPlayerRev (WizardGame value)
   {
      setCurrentPlayerRev (value);
      return this;
   }

   public WizardGame getCurrentPlayerRev ()
   {
      return this.currentPlayerRev;
   }

   public static final String PROPERTY_DEALER = "dealer";

   @Property( name = PROPERTY_DEALER, kind = ReferenceHandler.ReferenceKind.ATTRIBUTE )
   private boolean dealer;

   @Property( name = PROPERTY_DEALER )
   public void setDealer (boolean value)
   {
      this.dealer = value;
   }

   public Player withDealer (boolean value)
   {
      setDealer (value);
      return this;
   }

   @Property( name = PROPERTY_DEALER )
   public boolean isDealer ()
   {
      return this.dealer;
   }

   public void doForecast ()
   {
   }

   /**
    * <pre>
    *           0..1     forecasts     0..n
    * Player ------------------------- Forecast
    *           player               forecasts
    * </pre>
    */
   public static final String PROPERTY_FORECASTS = "forecasts";

   @Property( name = PROPERTY_FORECASTS, partner = Forecast.PROPERTY_PLAYER, kind = ReferenceHandler.ReferenceKind.TO_MANY,
         adornment = ReferenceHandler.Adornment.NONE)
   private FHashSet<Forecast> forecasts;

   @Property( name = PROPERTY_FORECASTS )
   public Set<? extends Forecast> getForecasts()
   {
      return ((this.forecasts == null)
              ? Collections.EMPTY_SET
              : Collections.unmodifiableSet(this.forecasts));
   }

   @Property( name = PROPERTY_FORECASTS )
   public boolean addToForecasts (Forecast value)
   {
      boolean changed = false;

      if (value != null)
      {
         if (this.forecasts == null)
         {
            this.forecasts = new FHashSet<Forecast> ();

         }
      
         changed = this.forecasts.add (value);
         if (changed)
         {
            value.setPlayer (this);
         }
      
      }
      return changed;
   }

   @Property( name = PROPERTY_FORECASTS )
   public Player withForecasts (Forecast value)
   {
      addToForecasts (value);
      return this;
   }

   public Player withoutForecasts (Forecast value)
   {
      removeFromForecasts (value);
      return this;
   }


   public boolean removeFromForecasts (Forecast value)
   {
      boolean changed = false;

      if ((this.forecasts != null) && (value != null))
      {
      
         changed = this.forecasts.remove (value);
         if (changed)
         {
            value.setPlayer (null);
         }
      
      }
      return changed;
   }

   @Property( name = PROPERTY_FORECASTS )
   public void removeAllFromForecasts (){
   
      Forecast tmpValue;
      Iterator<? extends Forecast> iter = this.iteratorOfForecasts ();
      while (iter.hasNext ())
      {
         tmpValue = (Forecast) iter.next ();
         this.removeFromForecasts (tmpValue);
      }
   
   }

   @Property( name = PROPERTY_FORECASTS )
   public boolean hasInForecasts (Forecast value)
   {
      return ((this.forecasts != null) &&
              (value != null) &&
              this.forecasts.contains (value));
   }

   @Property( name = PROPERTY_FORECASTS )
   public Iterator<? extends Forecast> iteratorOfForecasts ()
   {
      return ((this.forecasts == null)
              ? FEmptyIterator.<Forecast>get ()
              : this.forecasts.iterator ());
   }

   @Property( name = PROPERTY_FORECASTS )
   public int sizeOfForecasts ()
   {
      return ((this.forecasts == null)
              ? 0
              : this.forecasts.size ());
   }

   public static final String PROPERTY_NAME = "name";

   @Property( name = PROPERTY_NAME, kind = ReferenceHandler.ReferenceKind.ATTRIBUTE )
   private String name;

   @Property( name = PROPERTY_NAME )
   public void setName (String value)
   {
      this.name = value;
   }

   public Player withName (String value)
   {
      setName (value);
      return this;
   }

   @Property( name = PROPERTY_NAME )
   public String getName ()
   {
      return this.name;
   }

   /**
    * <pre>
    *           0..1     next     0..1
    * Player ------------------------- Player
    *           previous               next
    * </pre>
    */
   public static final String PROPERTY_NEXT = "next";

   @Property( name = PROPERTY_NEXT, partner = Player.PROPERTY_PREVIOUS, kind = ReferenceHandler.ReferenceKind.TO_ONE,
         adornment = ReferenceHandler.Adornment.NONE)
   private Player next;

   @Property( name = PROPERTY_NEXT )
   public boolean setNext (Player value)
   {
      boolean changed = false;

      if (this.next != value)
      {
      
         Player oldValue = this.next;
         Player source = this;
         if (this.next != null)
         {
            this.next = null;
            oldValue.setPrevious (null);
         }
         this.next = value;

         if (value != null)
         {
            value.setPrevious (this);
         }
         changed = true;
      
      }
      return changed;
   }

   @Property( name = PROPERTY_NEXT )
   public Player withNext (Player value)
   {
      setNext (value);
      return this;
   }

   public Player getNext ()
   {
      return this.next;
   }

   /**
    * <pre>
    *           0..1     next     0..1
    * Player ------------------------- Player
    *           next               previous
    * </pre>
    */
   public static final String PROPERTY_PREVIOUS = "previous";

   @Property( name = PROPERTY_PREVIOUS, partner = Player.PROPERTY_NEXT, kind = ReferenceHandler.ReferenceKind.TO_ONE,
         adornment = ReferenceHandler.Adornment.NONE)
   private Player previous;

   @Property( name = PROPERTY_PREVIOUS )
   public boolean setPrevious (Player value)
   {
      boolean changed = false;

      if (this.previous != value)
      {
      
         Player oldValue = this.previous;
         Player source = this;
         if (this.previous != null)
         {
            this.previous = null;
            oldValue.setNext (null);
         }
         this.previous = value;

         if (value != null)
         {
            value.setNext (this);
         }
         changed = true;
      
      }
      return changed;
   }

   @Property( name = PROPERTY_PREVIOUS )
   public Player withPrevious (Player value)
   {
      setPrevious (value);
      return this;
   }

   public Player getPrevious ()
   {
      return this.previous;
   }

   /**
    * <pre>
    *           0..1     tricks     0..n
    * Player ------------------------- Trick
    *           player               tricks
    * </pre>
    */
   public static final String PROPERTY_TRICKS = "tricks";

   @Property( name = PROPERTY_TRICKS, partner = Trick.PROPERTY_PLAYER, kind = ReferenceHandler.ReferenceKind.TO_MANY,
         adornment = ReferenceHandler.Adornment.NONE)
   private FHashSet<Trick> tricks;

   @Property( name = PROPERTY_TRICKS )
   public Set<? extends Trick> getTricks()
   {
      return ((this.tricks == null)
              ? Collections.EMPTY_SET
              : Collections.unmodifiableSet(this.tricks));
   }

   @Property( name = PROPERTY_TRICKS )
   public boolean addToTricks (Trick value)
   {
      boolean changed = false;

      if (value != null)
      {
         if (this.tricks == null)
         {
            this.tricks = new FHashSet<Trick> ();

         }
      
         changed = this.tricks.add (value);
         if (changed)
         {
            value.setPlayer (this);
         }
      
      }
      return changed;
   }

   @Property( name = PROPERTY_TRICKS )
   public Player withTricks (Trick value)
   {
      addToTricks (value);
      return this;
   }

   public Player withoutTricks (Trick value)
   {
      removeFromTricks (value);
      return this;
   }


   public boolean removeFromTricks (Trick value)
   {
      boolean changed = false;

      if ((this.tricks != null) && (value != null))
      {
      
         changed = this.tricks.remove (value);
         if (changed)
         {
            value.setPlayer (null);
         }
      
      }
      return changed;
   }

   @Property( name = PROPERTY_TRICKS )
   public void removeAllFromTricks (){
   
      Trick tmpValue;
      Iterator<? extends Trick> iter = this.iteratorOfTricks ();
      while (iter.hasNext ())
      {
         tmpValue = (Trick) iter.next ();
         this.removeFromTricks (tmpValue);
      }
   
   }

   @Property( name = PROPERTY_TRICKS )
   public boolean hasInTricks (Trick value)
   {
      return ((this.tricks != null) &&
              (value != null) &&
              this.tricks.contains (value));
   }

   @Property( name = PROPERTY_TRICKS )
   public Iterator<? extends Trick> iteratorOfTricks ()
   {
      return ((this.tricks == null)
              ? FEmptyIterator.<Trick>get ()
              : this.tricks.iterator ());
   }

   @Property( name = PROPERTY_TRICKS )
   public int sizeOfTricks ()
   {
      return ((this.tricks == null)
              ? 0
              : this.tricks.size ());
   }

   /**
    * <pre>
    *           0..1     winner     0..1
    * Player ------------------------- WizardGame
    *           winner               winnerRev
    * </pre>
    */
   public static final String PROPERTY_WINNER_REV = "winnerRev";

   @Property( name = PROPERTY_WINNER_REV, partner = WizardGame.PROPERTY_WINNER, kind = ReferenceHandler.ReferenceKind.TO_ONE,
         adornment = ReferenceHandler.Adornment.NONE)
   private WizardGame winnerRev;

   @Property( name = PROPERTY_WINNER_REV )
   public boolean setWinnerRev (WizardGame value)
   {
      boolean changed = false;

      if (this.winnerRev != value)
      {
      
         WizardGame oldValue = this.winnerRev;
         Player source = this;
         if (this.winnerRev != null)
         {
            this.winnerRev = null;
            oldValue.setWinner (null);
         }
         this.winnerRev = value;

         if (value != null)
         {
            value.setWinner (this);
         }
         changed = true;
      
      }
      return changed;
   }

   @Property( name = PROPERTY_WINNER_REV )
   public Player withWinnerRev (WizardGame value)
   {
      setWinnerRev (value);
      return this;
   }

   public WizardGame getWinnerRev ()
   {
      return this.winnerRev;
   }

   /**
    * <pre>
    *           0..n     players     0..1
    * Player ------------------------- WizardGame
    *           players               wizardGame
    * </pre>
    */
   public static final String PROPERTY_WIZARD_GAME = "wizardGame";

   @Property( name = PROPERTY_WIZARD_GAME, partner = WizardGame.PROPERTY_PLAYERS, kind = ReferenceHandler.ReferenceKind.TO_ONE,
         adornment = ReferenceHandler.Adornment.NONE)
   private WizardGame wizardGame;

   @Property( name = PROPERTY_WIZARD_GAME )
   public boolean setWizardGame (WizardGame value)
   {
      boolean changed = false;

      if (this.wizardGame != value)
      {
      
         WizardGame oldValue = this.wizardGame;
         Player source = this;
         if (this.wizardGame != null)
         {
            this.wizardGame = null;
            oldValue.removeFromPlayers (this);
         }
         this.wizardGame = value;

         if (value != null)
         {
            value.addToPlayers (this);
         }
         changed = true;
      
      }
      return changed;
   }

   @Property( name = PROPERTY_WIZARD_GAME )
   public Player withWizardGame (WizardGame value)
   {
      setWizardGame (value);
      return this;
   }

   public WizardGame getWizardGame ()
   {
      return this.wizardGame;
   }

   /**
    * <pre>
    *           0..1     winner     0..n
    * Player ------------------------- Turn
    *           winner               wonTurns
    * </pre>
    */
   public static final String PROPERTY_WON_TURNS = "wonTurns";

   @Property( name = PROPERTY_WON_TURNS, partner = Turn.PROPERTY_WINNER, kind = ReferenceHandler.ReferenceKind.TO_MANY,
         adornment = ReferenceHandler.Adornment.NONE)
   private FHashSet<Turn> wonTurns;

   @Property( name = PROPERTY_WON_TURNS )
   public Set<? extends Turn> getWonTurns()
   {
      return ((this.wonTurns == null)
              ? Collections.EMPTY_SET
              : Collections.unmodifiableSet(this.wonTurns));
   }

   @Property( name = PROPERTY_WON_TURNS )
   public boolean addToWonTurns (Turn value)
   {
      boolean changed = false;

      if (value != null)
      {
         if (this.wonTurns == null)
         {
            this.wonTurns = new FHashSet<Turn> ();

         }
      
         changed = this.wonTurns.add (value);
         if (changed)
         {
            value.setWinner (this);
         }
      
      }
      return changed;
   }

   @Property( name = PROPERTY_WON_TURNS )
   public Player withWonTurns (Turn value)
   {
      addToWonTurns (value);
      return this;
   }

   public Player withoutWonTurns (Turn value)
   {
      removeFromWonTurns (value);
      return this;
   }


   public boolean removeFromWonTurns (Turn value)
   {
      boolean changed = false;

      if ((this.wonTurns != null) && (value != null))
      {
      
         changed = this.wonTurns.remove (value);
         if (changed)
         {
            value.setWinner (null);
         }
      
      }
      return changed;
   }

   @Property( name = PROPERTY_WON_TURNS )
   public void removeAllFromWonTurns (){
   
      Turn tmpValue;
      Iterator<? extends Turn> iter = this.iteratorOfWonTurns ();
      while (iter.hasNext ())
      {
         tmpValue = (Turn) iter.next ();
         this.removeFromWonTurns (tmpValue);
      }
   
   }

   @Property( name = PROPERTY_WON_TURNS )
   public boolean hasInWonTurns (Turn value)
   {
      return ((this.wonTurns != null) &&
              (value != null) &&
              this.wonTurns.contains (value));
   }

   @Property( name = PROPERTY_WON_TURNS )
   public Iterator<? extends Turn> iteratorOfWonTurns ()
   {
      return ((this.wonTurns == null)
              ? FEmptyIterator.<Turn>get ()
              : this.wonTurns.iterator ());
   }

   @Property( name = PROPERTY_WON_TURNS )
   public int sizeOfWonTurns ()
   {
      return ((this.wonTurns == null)
              ? 0
              : this.wonTurns.size ());
   }

   public void removeYou()
   {
      this.removeAllFromCards ();
      this.setCurrentPlayerRev (null);
      this.removeAllFromForecasts ();
      this.setNext (null);
      this.setPrevious (null);
      this.removeAllFromTricks ();
      this.setWinnerRev (null);
      this.setWizardGame (null);
      this.removeAllFromWonTurns ();
   }
}


