/*
 * generated by Fujaba - CodeGen2
 */
package de.uks.pmss11.wizard;
import de.uni_kassel.features.annotation.util.Property; // requires Fujaba5/libs/features.jar in classpath
import de.uni_kassel.features.ReferenceHandler; // requires Fujaba5/libs/features.jar in classpath
import java.util.*;
import de.upb.tools.fca.*; // requires Fujaba5/libs/RuntimeTools.jar in classpath


public class Stack
{



   /**
    * <pre>
    *           0..1     cards     0..n
    * Stack ------------------------- Card
    *           stack               cards
    * </pre>
    */
   public static final String PROPERTY_CARDS = "cards";

   @Property( name = PROPERTY_CARDS, partner = Card.PROPERTY_STACK, kind = ReferenceHandler.ReferenceKind.TO_MANY,
         adornment = ReferenceHandler.Adornment.NONE)
   private FHashSet<Card> cards;

   @Property( name = PROPERTY_CARDS )
   public Set<? extends Card> getCards()
   {
      return ((this.cards == null)
              ? Collections.EMPTY_SET
              : Collections.unmodifiableSet(this.cards));
   }

   @Property( name = PROPERTY_CARDS )
   public boolean addToCards (Card value)
   {
      boolean changed = false;

      if (value != null)
      {
         if (this.cards == null)
         {
            this.cards = new FHashSet<Card> ();

         }
      
         changed = this.cards.add (value);
         if (changed)
         {
            value.setStack (this);
         }
      
      }
      return changed;
   }

   @Property( name = PROPERTY_CARDS )
   public Stack withCards (Card value)
   {
      addToCards (value);
      return this;
   }

   public Stack withoutCards (Card value)
   {
      removeFromCards (value);
      return this;
   }


   public boolean removeFromCards (Card value)
   {
      boolean changed = false;

      if ((this.cards != null) && (value != null))
      {
      
         changed = this.cards.remove (value);
         if (changed)
         {
            value.setStack (null);
         }
      
      }
      return changed;
   }

   @Property( name = PROPERTY_CARDS )
   public void removeAllFromCards (){
   
      Card tmpValue;
      Iterator<? extends Card> iter = this.iteratorOfCards ();
      while (iter.hasNext ())
      {
         tmpValue = (Card) iter.next ();
         this.removeFromCards (tmpValue);
      }
   
   }

   @Property( name = PROPERTY_CARDS )
   public boolean hasInCards (Card value)
   {
      return ((this.cards != null) &&
              (value != null) &&
              this.cards.contains (value));
   }

   @Property( name = PROPERTY_CARDS )
   public Iterator<? extends Card> iteratorOfCards ()
   {
      return ((this.cards == null)
              ? FEmptyIterator.<Card>get ()
              : this.cards.iterator ());
   }

   @Property( name = PROPERTY_CARDS )
   public int sizeOfCards ()
   {
      return ((this.cards == null)
              ? 0
              : this.cards.size ());
   }

   /**
    * <pre>
    *           0..1     closedStack     0..1
    * Stack ------------------------- WizardGame
    *           closedStack               wizardCStackRev
    * </pre>
    */
   public static final String PROPERTY_WIZARDC_STACK_REV = "wizardCStackRev";

   @Property( name = PROPERTY_WIZARDC_STACK_REV, partner = WizardGame.PROPERTY_CLOSED_STACK, kind = ReferenceHandler.ReferenceKind.TO_ONE,
         adornment = ReferenceHandler.Adornment.NONE)
   private WizardGame wizardCStackRev;

   @Property( name = PROPERTY_WIZARDC_STACK_REV )
   public boolean setWizardCStackRev (WizardGame value)
   {
      boolean changed = false;

      if (this.wizardCStackRev != value)
      {
      
         WizardGame oldValue = this.wizardCStackRev;
         Stack source = this;
         if (this.wizardCStackRev != null)
         {
            this.wizardCStackRev = null;
            oldValue.setClosedStack (null);
         }
         this.wizardCStackRev = value;

         if (value != null)
         {
            value.setClosedStack (this);
         }
         changed = true;
      
      }
      return changed;
   }

   @Property( name = PROPERTY_WIZARDC_STACK_REV )
   public Stack withWizardCStackRev (WizardGame value)
   {
      setWizardCStackRev (value);
      return this;
   }

   public WizardGame getWizardCStackRev ()
   {
      return this.wizardCStackRev;
   }

   /**
    * <pre>
    *           0..1     openStack     0..1
    * Stack ------------------------- WizardGame
    *           openStack               wizardOStackRev
    * </pre>
    */
   public static final String PROPERTY_WIZARDO_STACK_REV = "wizardOStackRev";

   @Property( name = PROPERTY_WIZARDO_STACK_REV, partner = WizardGame.PROPERTY_OPEN_STACK, kind = ReferenceHandler.ReferenceKind.TO_ONE,
         adornment = ReferenceHandler.Adornment.NONE)
   private WizardGame wizardOStackRev;

   @Property( name = PROPERTY_WIZARDO_STACK_REV )
   public boolean setWizardOStackRev (WizardGame value)
   {
      boolean changed = false;

      if (this.wizardOStackRev != value)
      {
      
         WizardGame oldValue = this.wizardOStackRev;
         Stack source = this;
         if (this.wizardOStackRev != null)
         {
            this.wizardOStackRev = null;
            oldValue.setOpenStack (null);
         }
         this.wizardOStackRev = value;

         if (value != null)
         {
            value.setOpenStack (this);
         }
         changed = true;
      
      }
      return changed;
   }

   @Property( name = PROPERTY_WIZARDO_STACK_REV )
   public Stack withWizardOStackRev (WizardGame value)
   {
      setWizardOStackRev (value);
      return this;
   }

   public WizardGame getWizardOStackRev ()
   {
      return this.wizardOStackRev;
   }

   public void removeYou()
   {
      this.removeAllFromCards ();
      this.setWizardCStackRev (null);
      this.setWizardOStackRev (null);
   }
}


