/*
 * generated by Fujaba - CodeGen2
 */
package de.uks.pmss11.wizard;
import de.uni_kassel.features.annotation.util.Property; // requires Fujaba5/libs/features.jar in classpath
import de.uni_kassel.features.ReferenceHandler; // requires Fujaba5/libs/features.jar in classpath
import java.util.*;
import de.upb.tools.fca.*; // requires Fujaba5/libs/RuntimeTools.jar in classpath


public class Trick
{



   /**
    * <pre>
    *           0..n     cards     0..n
    * Trick ------------------------- Card
    *           tricks               cards
    * </pre>
    */
   public static final String PROPERTY_CARDS = "cards";

   @Property( name = PROPERTY_CARDS, partner = Card.PROPERTY_TRICKS, kind = ReferenceHandler.ReferenceKind.TO_MANY,
         adornment = ReferenceHandler.Adornment.NONE)
   private FHashSet<Card> cards;

   @Property( name = PROPERTY_CARDS )
   public Set<? extends Card> getCards()
   {
      return ((this.cards == null)
              ? Collections.EMPTY_SET
              : Collections.unmodifiableSet(this.cards));
   }

   @Property( name = PROPERTY_CARDS )
   public boolean addToCards (Card value)
   {
      boolean changed = false;

      if (value != null)
      {
         if (this.cards == null)
         {
            this.cards = new FHashSet<Card> ();

         }
      
         changed = this.cards.add (value);
         if (changed)
         {
            value.addToTricks (this);
         }
      
      }
      return changed;
   }

   @Property( name = PROPERTY_CARDS )
   public Trick withCards (Card value)
   {
      addToCards (value);
      return this;
   }

   public Trick withoutCards (Card value)
   {
      removeFromCards (value);
      return this;
   }


   public boolean removeFromCards (Card value)
   {
      boolean changed = false;

      if ((this.cards != null) && (value != null))
      {
      
         changed = this.cards.remove (value);
         if (changed)
         {
            value.removeFromTricks (this);
         }
      
      }
      return changed;
   }

   @Property( name = PROPERTY_CARDS )
   public void removeAllFromCards (){
   
      Card tmpValue;
      Iterator<? extends Card> iter = this.iteratorOfCards ();
      while (iter.hasNext ())
      {
         tmpValue = (Card) iter.next ();
         this.removeFromCards (tmpValue);
      }
   
   }

   @Property( name = PROPERTY_CARDS )
   public boolean hasInCards (Card value)
   {
      return ((this.cards != null) &&
              (value != null) &&
              this.cards.contains (value));
   }

   @Property( name = PROPERTY_CARDS )
   public Iterator<? extends Card> iteratorOfCards ()
   {
      return ((this.cards == null)
              ? FEmptyIterator.<Card>get ()
              : this.cards.iterator ());
   }

   @Property( name = PROPERTY_CARDS )
   public int sizeOfCards ()
   {
      return ((this.cards == null)
              ? 0
              : this.cards.size ());
   }

   /**
    * <pre>
    *           0..n     tricks     0..1
    * Trick ------------------------- Player
    *           tricks               player
    * </pre>
    */
   public static final String PROPERTY_PLAYER = "player";

   @Property( name = PROPERTY_PLAYER, partner = Player.PROPERTY_TRICKS, kind = ReferenceHandler.ReferenceKind.TO_ONE,
         adornment = ReferenceHandler.Adornment.NONE)
   private Player player;

   @Property( name = PROPERTY_PLAYER )
   public boolean setPlayer (Player value)
   {
      boolean changed = false;

      if (this.player != value)
      {
      
         Player oldValue = this.player;
         Trick source = this;
         if (this.player != null)
         {
            this.player = null;
            oldValue.removeFromTricks (this);
         }
         this.player = value;

         if (value != null)
         {
            value.addToTricks (this);
         }
         changed = true;
      
      }
      return changed;
   }

   @Property( name = PROPERTY_PLAYER )
   public Trick withPlayer (Player value)
   {
      setPlayer (value);
      return this;
   }

   public Player getPlayer ()
   {
      return this.player;
   }

   /**
    * <pre>
    *           0..n     turn     0..1
    * Trick ------------------------- Turn
    *           tricks               turn
    * </pre>
    */
   public static final String PROPERTY_TURN = "turn";

   @Property( name = PROPERTY_TURN, partner = Turn.PROPERTY_TRICKS, kind = ReferenceHandler.ReferenceKind.TO_ONE,
         adornment = ReferenceHandler.Adornment.NONE)
   private Turn turn;

   @Property( name = PROPERTY_TURN )
   public boolean setTurn (Turn value)
   {
      boolean changed = false;

      if (this.turn != value)
      {
      
         Turn oldValue = this.turn;
         Trick source = this;
         if (this.turn != null)
         {
            this.turn = null;
            oldValue.removeFromTricks (this);
         }
         this.turn = value;

         if (value != null)
         {
            value.addToTricks (this);
         }
         changed = true;
      
      }
      return changed;
   }

   @Property( name = PROPERTY_TURN )
   public Trick withTurn (Turn value)
   {
      setTurn (value);
      return this;
   }

   public Turn getTurn ()
   {
      return this.turn;
   }

   public void removeYou()
   {
      this.removeAllFromCards ();
      this.setPlayer (null);
      this.setTurn (null);
   }
}


