/*
 * generated by Fujaba - CodeGen2
 */
package de.uks.pmss11.wizard;
import de.uni_kassel.features.annotation.util.Property; // requires Fujaba5/libs/features.jar in classpath
import de.uni_kassel.features.ReferenceHandler; // requires Fujaba5/libs/features.jar in classpath
import java.util.*;
import de.upb.tools.fca.*; // requires Fujaba5/libs/RuntimeTools.jar in classpath


public class Turn
{



   /**
    * <pre>
    *           0..1     turn     0..n
    * Turn ------------------------- Forecast
    *           turn               forecasts
    * </pre>
    */
   public static final String PROPERTY_FORECASTS = "forecasts";

   @Property( name = PROPERTY_FORECASTS, partner = Forecast.PROPERTY_TURN, kind = ReferenceHandler.ReferenceKind.TO_MANY,
         adornment = ReferenceHandler.Adornment.NONE)
   private FHashSet<Forecast> forecasts;

   @Property( name = PROPERTY_FORECASTS )
   public Set<? extends Forecast> getForecasts()
   {
      return ((this.forecasts == null)
              ? Collections.EMPTY_SET
              : Collections.unmodifiableSet(this.forecasts));
   }

   @Property( name = PROPERTY_FORECASTS )
   public boolean addToForecasts (Forecast value)
   {
      boolean changed = false;

      if (value != null)
      {
         if (this.forecasts == null)
         {
            this.forecasts = new FHashSet<Forecast> ();

         }
      
         changed = this.forecasts.add (value);
         if (changed)
         {
            value.setTurn (this);
         }
      
      }
      return changed;
   }

   @Property( name = PROPERTY_FORECASTS )
   public Turn withForecasts (Forecast value)
   {
      addToForecasts (value);
      return this;
   }

   public Turn withoutForecasts (Forecast value)
   {
      removeFromForecasts (value);
      return this;
   }


   public boolean removeFromForecasts (Forecast value)
   {
      boolean changed = false;

      if ((this.forecasts != null) && (value != null))
      {
      
         changed = this.forecasts.remove (value);
         if (changed)
         {
            value.setTurn (null);
         }
      
      }
      return changed;
   }

   @Property( name = PROPERTY_FORECASTS )
   public void removeAllFromForecasts (){
   
      Forecast tmpValue;
      Iterator<? extends Forecast> iter = this.iteratorOfForecasts ();
      while (iter.hasNext ())
      {
         tmpValue = (Forecast) iter.next ();
         this.removeFromForecasts (tmpValue);
      }
   
   }

   @Property( name = PROPERTY_FORECASTS )
   public boolean hasInForecasts (Forecast value)
   {
      return ((this.forecasts != null) &&
              (value != null) &&
              this.forecasts.contains (value));
   }

   @Property( name = PROPERTY_FORECASTS )
   public Iterator<? extends Forecast> iteratorOfForecasts ()
   {
      return ((this.forecasts == null)
              ? FEmptyIterator.<Forecast>get ()
              : this.forecasts.iterator ());
   }

   @Property( name = PROPERTY_FORECASTS )
   public int sizeOfForecasts ()
   {
      return ((this.forecasts == null)
              ? 0
              : this.forecasts.size ());
   }

   public static final String PROPERTY_NUMBER = "number";

   @Property( name = PROPERTY_NUMBER, kind = ReferenceHandler.ReferenceKind.ATTRIBUTE )
   private int number;

   @Property( name = PROPERTY_NUMBER )
   public void setNumber (int value)
   {
      this.number = value;
   }

   public Turn withNumber (int value)
   {
      setNumber (value);
      return this;
   }

   @Property( name = PROPERTY_NUMBER )
   public int getNumber ()
   {
      return this.number;
   }

   /**
    * <pre>
    *           0..1     turn     0..n
    * Turn ------------------------- Trick
    *           turn               tricks
    * </pre>
    */
   public static final String PROPERTY_TRICKS = "tricks";

   @Property( name = PROPERTY_TRICKS, partner = Trick.PROPERTY_TURN, kind = ReferenceHandler.ReferenceKind.TO_MANY,
         adornment = ReferenceHandler.Adornment.NONE)
   private FHashSet<Trick> tricks;

   @Property( name = PROPERTY_TRICKS )
   public Set<? extends Trick> getTricks()
   {
      return ((this.tricks == null)
              ? Collections.EMPTY_SET
              : Collections.unmodifiableSet(this.tricks));
   }

   @Property( name = PROPERTY_TRICKS )
   public boolean addToTricks (Trick value)
   {
      boolean changed = false;

      if (value != null)
      {
         if (this.tricks == null)
         {
            this.tricks = new FHashSet<Trick> ();

         }
      
         changed = this.tricks.add (value);
         if (changed)
         {
            value.setTurn (this);
         }
      
      }
      return changed;
   }

   @Property( name = PROPERTY_TRICKS )
   public Turn withTricks (Trick value)
   {
      addToTricks (value);
      return this;
   }

   public Turn withoutTricks (Trick value)
   {
      removeFromTricks (value);
      return this;
   }


   public boolean removeFromTricks (Trick value)
   {
      boolean changed = false;

      if ((this.tricks != null) && (value != null))
      {
      
         changed = this.tricks.remove (value);
         if (changed)
         {
            value.setTurn (null);
         }
      
      }
      return changed;
   }

   @Property( name = PROPERTY_TRICKS )
   public void removeAllFromTricks (){
   
      Trick tmpValue;
      Iterator<? extends Trick> iter = this.iteratorOfTricks ();
      while (iter.hasNext ())
      {
         tmpValue = (Trick) iter.next ();
         this.removeFromTricks (tmpValue);
      }
   
   }

   @Property( name = PROPERTY_TRICKS )
   public boolean hasInTricks (Trick value)
   {
      return ((this.tricks != null) &&
              (value != null) &&
              this.tricks.contains (value));
   }

   @Property( name = PROPERTY_TRICKS )
   public Iterator<? extends Trick> iteratorOfTricks ()
   {
      return ((this.tricks == null)
              ? FEmptyIterator.<Trick>get ()
              : this.tricks.iterator ());
   }

   @Property( name = PROPERTY_TRICKS )
   public int sizeOfTricks ()
   {
      return ((this.tricks == null)
              ? 0
              : this.tricks.size ());
   }

   /**
    * <pre>
    *           0..1     trump     0..1
    * Turn ------------------------- Card
    *           turn               trump
    * </pre>
    */
   public static final String PROPERTY_TRUMP = "trump";

   @Property( name = PROPERTY_TRUMP, partner = Card.PROPERTY_TURN, kind = ReferenceHandler.ReferenceKind.TO_ONE,
         adornment = ReferenceHandler.Adornment.NONE)
   private Card trump;

   @Property( name = PROPERTY_TRUMP )
   public boolean setTrump (Card value)
   {
      boolean changed = false;

      if (this.trump != value)
      {
      
         Card oldValue = this.trump;
         Turn source = this;
         if (this.trump != null)
         {
            this.trump = null;
            oldValue.setTurn (null);
         }
         this.trump = value;

         if (value != null)
         {
            value.setTurn (this);
         }
         changed = true;
      
      }
      return changed;
   }

   @Property( name = PROPERTY_TRUMP )
   public Turn withTrump (Card value)
   {
      setTrump (value);
      return this;
   }

   public Card getTrump ()
   {
      return this.trump;
   }

   /**
    * <pre>
    *           0..n     winner     0..1
    * Turn ------------------------- Player
    *           wonTurns               winner
    * </pre>
    */
   public static final String PROPERTY_WINNER = "winner";

   @Property( name = PROPERTY_WINNER, partner = Player.PROPERTY_WON_TURNS, kind = ReferenceHandler.ReferenceKind.TO_ONE,
         adornment = ReferenceHandler.Adornment.NONE)
   private Player winner;

   @Property( name = PROPERTY_WINNER )
   public boolean setWinner (Player value)
   {
      boolean changed = false;

      if (this.winner != value)
      {
      
         Player oldValue = this.winner;
         Turn source = this;
         if (this.winner != null)
         {
            this.winner = null;
            oldValue.removeFromWonTurns (this);
         }
         this.winner = value;

         if (value != null)
         {
            value.addToWonTurns (this);
         }
         changed = true;
      
      }
      return changed;
   }

   @Property( name = PROPERTY_WINNER )
   public Turn withWinner (Player value)
   {
      setWinner (value);
      return this;
   }

   public Player getWinner ()
   {
      return this.winner;
   }

   /**
    * <pre>
    *           0..n     turns     0..1
    * Turn ------------------------- WizardGame
    *           turns               wizardGame
    * </pre>
    */
   public static final String PROPERTY_WIZARD_GAME = "wizardGame";

   @Property( name = PROPERTY_WIZARD_GAME, partner = WizardGame.PROPERTY_TURNS, kind = ReferenceHandler.ReferenceKind.TO_ONE,
         adornment = ReferenceHandler.Adornment.NONE)
   private WizardGame wizardGame;

   @Property( name = PROPERTY_WIZARD_GAME )
   public boolean setWizardGame (WizardGame value)
   {
      boolean changed = false;

      if (this.wizardGame != value)
      {
      
         WizardGame oldValue = this.wizardGame;
         Turn source = this;
         if (this.wizardGame != null)
         {
            this.wizardGame = null;
            oldValue.removeFromTurns (this);
         }
         this.wizardGame = value;

         if (value != null)
         {
            value.addToTurns (this);
         }
         changed = true;
      
      }
      return changed;
   }

   @Property( name = PROPERTY_WIZARD_GAME )
   public Turn withWizardGame (WizardGame value)
   {
      setWizardGame (value);
      return this;
   }

   public WizardGame getWizardGame ()
   {
      return this.wizardGame;
   }

   public void removeYou()
   {
      this.removeAllFromForecasts ();
      this.removeAllFromTricks ();
      this.setTrump (null);
      this.setWinner (null);
      this.setWizardGame (null);
   }
}


