/*
 * generated by Fujaba - CodeGen2
 */
package de.uks.pmss11.wizard;
import de.uni_kassel.features.annotation.util.Property; // requires Fujaba5/libs/features.jar in classpath
import de.uni_kassel.features.ReferenceHandler; // requires Fujaba5/libs/features.jar in classpath
import java.util.*;
import de.upb.tools.fca.*; // requires Fujaba5/libs/RuntimeTools.jar in classpath


public class WizardGame
{



   /**
    * <pre>
    *           0..1     closedStack     0..1
    * WizardGame ------------------------- Stack
    *           wizardCStackRev               closedStack
    * </pre>
    */
   public static final String PROPERTY_CLOSED_STACK = "closedStack";

   @Property( name = PROPERTY_CLOSED_STACK, partner = Stack.PROPERTY_WIZARDC_STACK_REV, kind = ReferenceHandler.ReferenceKind.TO_ONE,
         adornment = ReferenceHandler.Adornment.NONE)
   private Stack closedStack;

   @Property( name = PROPERTY_CLOSED_STACK )
   public boolean setClosedStack (Stack value)
   {
      boolean changed = false;

      if (this.closedStack != value)
      {
      
         Stack oldValue = this.closedStack;
         WizardGame source = this;
         if (this.closedStack != null)
         {
            this.closedStack = null;
            oldValue.setWizardCStackRev (null);
         }
         this.closedStack = value;

         if (value != null)
         {
            value.setWizardCStackRev (this);
         }
         changed = true;
      
      }
      return changed;
   }

   @Property( name = PROPERTY_CLOSED_STACK )
   public WizardGame withClosedStack (Stack value)
   {
      setClosedStack (value);
      return this;
   }

   public Stack getClosedStack ()
   {
      return this.closedStack;
   }

   /**
    * <pre>
    *           0..1     currentPlayer     0..1
    * WizardGame ------------------------- Player
    *           currentPlayerRev               currentPlayer
    * </pre>
    */
   public static final String PROPERTY_CURRENT_PLAYER = "currentPlayer";

   @Property( name = PROPERTY_CURRENT_PLAYER, partner = Player.PROPERTY_CURRENT_PLAYER_REV, kind = ReferenceHandler.ReferenceKind.TO_ONE,
         adornment = ReferenceHandler.Adornment.NONE)
   private Player currentPlayer;

   @Property( name = PROPERTY_CURRENT_PLAYER )
   public boolean setCurrentPlayer (Player value)
   {
      boolean changed = false;

      if (this.currentPlayer != value)
      {
      
         Player oldValue = this.currentPlayer;
         WizardGame source = this;
         if (this.currentPlayer != null)
         {
            this.currentPlayer = null;
            oldValue.setCurrentPlayerRev (null);
         }
         this.currentPlayer = value;

         if (value != null)
         {
            value.setCurrentPlayerRev (this);
         }
         changed = true;
      
      }
      return changed;
   }

   @Property( name = PROPERTY_CURRENT_PLAYER )
   public WizardGame withCurrentPlayer (Player value)
   {
      setCurrentPlayer (value);
      return this;
   }

   public Player getCurrentPlayer ()
   {
      return this.currentPlayer;
   }

   /**
    * <pre>
    *           0..1     currentTurn     0..1
    * WizardGame ------------------------> Turn
    *           currentTurnRev               currentTurn
    * </pre>
    */
   public static final String PROPERTY_CURRENT_TURN = "currentTurn";

   @Property( name = PROPERTY_CURRENT_TURN, kind = ReferenceHandler.ReferenceKind.TO_ONE,
         adornment = ReferenceHandler.Adornment.NONE)
   private Turn currentTurn;

   @Property( name = PROPERTY_CURRENT_TURN )
   public boolean setCurrentTurn (Turn value)
   {
      boolean changed = false;

      if (this.currentTurn != value)
      {
      
         Turn oldValue = this.currentTurn;
         this.currentTurn = value;
         changed = true;
      
      }
      return changed;
   }

   @Property( name = PROPERTY_CURRENT_TURN )
   public WizardGame withCurrentTurn (Turn value)
   {
      setCurrentTurn (value);
      return this;
   }

   public Turn getCurrentTurn ()
   {
      return this.currentTurn;
   }

   public void init (String[] playerNames )
   {
   }

   /**
    * <pre>
    *           0..1     openStack     0..1
    * WizardGame ------------------------- Stack
    *           wizardOStackRev               openStack
    * </pre>
    */
   public static final String PROPERTY_OPEN_STACK = "openStack";

   @Property( name = PROPERTY_OPEN_STACK, partner = Stack.PROPERTY_WIZARDO_STACK_REV, kind = ReferenceHandler.ReferenceKind.TO_ONE,
         adornment = ReferenceHandler.Adornment.NONE)
   private Stack openStack;

   @Property( name = PROPERTY_OPEN_STACK )
   public boolean setOpenStack (Stack value)
   {
      boolean changed = false;

      if (this.openStack != value)
      {
      
         Stack oldValue = this.openStack;
         WizardGame source = this;
         if (this.openStack != null)
         {
            this.openStack = null;
            oldValue.setWizardOStackRev (null);
         }
         this.openStack = value;

         if (value != null)
         {
            value.setWizardOStackRev (this);
         }
         changed = true;
      
      }
      return changed;
   }

   @Property( name = PROPERTY_OPEN_STACK )
   public WizardGame withOpenStack (Stack value)
   {
      setOpenStack (value);
      return this;
   }

   public Stack getOpenStack ()
   {
      return this.openStack;
   }

   /**
    * <pre>
    *           0..1     players     0..n
    * WizardGame ------------------------- Player
    *           wizardGame               players
    * </pre>
    */
   public static final String PROPERTY_PLAYERS = "players";

   @Property( name = PROPERTY_PLAYERS, partner = Player.PROPERTY_WIZARD_GAME, kind = ReferenceHandler.ReferenceKind.TO_MANY,
         adornment = ReferenceHandler.Adornment.NONE)
   private FHashSet<Player> players;

   @Property( name = PROPERTY_PLAYERS )
   public Set<? extends Player> getPlayers()
   {
      return ((this.players == null)
              ? Collections.EMPTY_SET
              : Collections.unmodifiableSet(this.players));
   }

   @Property( name = PROPERTY_PLAYERS )
   public boolean addToPlayers (Player value)
   {
      boolean changed = false;

      if (value != null)
      {
         if (this.players == null)
         {
            this.players = new FHashSet<Player> ();

         }
      
         changed = this.players.add (value);
         if (changed)
         {
            value.setWizardGame (this);
         }
      
      }
      return changed;
   }

   @Property( name = PROPERTY_PLAYERS )
   public WizardGame withPlayers (Player value)
   {
      addToPlayers (value);
      return this;
   }

   public WizardGame withoutPlayers (Player value)
   {
      removeFromPlayers (value);
      return this;
   }


   public boolean removeFromPlayers (Player value)
   {
      boolean changed = false;

      if ((this.players != null) && (value != null))
      {
      
         changed = this.players.remove (value);
         if (changed)
         {
            value.setWizardGame (null);
         }
      
      }
      return changed;
   }

   @Property( name = PROPERTY_PLAYERS )
   public void removeAllFromPlayers (){
   
      Player tmpValue;
      Iterator<? extends Player> iter = this.iteratorOfPlayers ();
      while (iter.hasNext ())
      {
         tmpValue = (Player) iter.next ();
         this.removeFromPlayers (tmpValue);
      }
   
   }

   @Property( name = PROPERTY_PLAYERS )
   public boolean hasInPlayers (Player value)
   {
      return ((this.players != null) &&
              (value != null) &&
              this.players.contains (value));
   }

   @Property( name = PROPERTY_PLAYERS )
   public Iterator<? extends Player> iteratorOfPlayers ()
   {
      return ((this.players == null)
              ? FEmptyIterator.<Player>get ()
              : this.players.iterator ());
   }

   @Property( name = PROPERTY_PLAYERS )
   public int sizeOfPlayers ()
   {
      return ((this.players == null)
              ? 0
              : this.players.size ());
   }

   /**
    * <pre>
    *           0..1     turns     0..n
    * WizardGame ------------------------- Turn
    *           wizardGame               turns
    * </pre>
    */
   public static final String PROPERTY_TURNS = "turns";

   @Property( name = PROPERTY_TURNS, partner = Turn.PROPERTY_WIZARD_GAME, kind = ReferenceHandler.ReferenceKind.TO_MANY,
         adornment = ReferenceHandler.Adornment.NONE)
   private FHashSet<Turn> turns;

   @Property( name = PROPERTY_TURNS )
   public Set<? extends Turn> getTurns()
   {
      return ((this.turns == null)
              ? Collections.EMPTY_SET
              : Collections.unmodifiableSet(this.turns));
   }

   @Property( name = PROPERTY_TURNS )
   public boolean addToTurns (Turn value)
   {
      boolean changed = false;

      if (value != null)
      {
         if (this.turns == null)
         {
            this.turns = new FHashSet<Turn> ();

         }
      
         changed = this.turns.add (value);
         if (changed)
         {
            value.setWizardGame (this);
         }
      
      }
      return changed;
   }

   @Property( name = PROPERTY_TURNS )
   public WizardGame withTurns (Turn value)
   {
      addToTurns (value);
      return this;
   }

   public WizardGame withoutTurns (Turn value)
   {
      removeFromTurns (value);
      return this;
   }


   public boolean removeFromTurns (Turn value)
   {
      boolean changed = false;

      if ((this.turns != null) && (value != null))
      {
      
         changed = this.turns.remove (value);
         if (changed)
         {
            value.setWizardGame (null);
         }
      
      }
      return changed;
   }

   @Property( name = PROPERTY_TURNS )
   public void removeAllFromTurns (){
   
      Turn tmpValue;
      Iterator<? extends Turn> iter = this.iteratorOfTurns ();
      while (iter.hasNext ())
      {
         tmpValue = (Turn) iter.next ();
         this.removeFromTurns (tmpValue);
      }
   
   }

   @Property( name = PROPERTY_TURNS )
   public boolean hasInTurns (Turn value)
   {
      return ((this.turns != null) &&
              (value != null) &&
              this.turns.contains (value));
   }

   @Property( name = PROPERTY_TURNS )
   public Iterator<? extends Turn> iteratorOfTurns ()
   {
      return ((this.turns == null)
              ? FEmptyIterator.<Turn>get ()
              : this.turns.iterator ());
   }

   @Property( name = PROPERTY_TURNS )
   public int sizeOfTurns ()
   {
      return ((this.turns == null)
              ? 0
              : this.turns.size ());
   }

   /**
    * <pre>
    *           0..1     winner     0..1
    * WizardGame ------------------------- Player
    *           winnerRev               winner
    * </pre>
    */
   public static final String PROPERTY_WINNER = "winner";

   @Property( name = PROPERTY_WINNER, partner = Player.PROPERTY_WINNER_REV, kind = ReferenceHandler.ReferenceKind.TO_ONE,
         adornment = ReferenceHandler.Adornment.NONE)
   private Player winner;

   @Property( name = PROPERTY_WINNER )
   public boolean setWinner (Player value)
   {
      boolean changed = false;

      if (this.winner != value)
      {
      
         Player oldValue = this.winner;
         WizardGame source = this;
         if (this.winner != null)
         {
            this.winner = null;
            oldValue.setWinnerRev (null);
         }
         this.winner = value;

         if (value != null)
         {
            value.setWinnerRev (this);
         }
         changed = true;
      
      }
      return changed;
   }

   @Property( name = PROPERTY_WINNER )
   public WizardGame withWinner (Player value)
   {
      setWinner (value);
      return this;
   }

   public Player getWinner ()
   {
      return this.winner;
   }

   public void removeYou()
   {
      this.setClosedStack (null);
      this.setCurrentPlayer (null);
      this.setCurrentTurn (null);
      this.setOpenStack (null);
      this.removeAllFromPlayers ();
      this.removeAllFromTurns ();
      this.setWinner (null);
   }
}


